class Car():
    """一次模拟汽车的简单尝试"""
    def __init__(self, make, model, year):
        self.make = make
        self.model = model
        self.year = year
        # 给属性指定默认值
        self.odometer_reading = 0

    def get_descriptive_name(self):
        """返回整洁的描述性信息"""
        long_name = str(self.year) + ' ' + self.make + ' ' + self.model
        return long_name.title()

    def read_odometer(self):
        """打印一条指出汽车里程的消息"""
        print('The Car has ' + str(self.odometer_reading) + ' miles on it.')

    def update_odometer(self, mileage):
        """将里程表读数设置为指定的值"""
        self.odometer_reading = mileage

    def increment_odometer(self, miles):
        self.odometer_reading += miles

    def fill_gas_tank(self):
        """普通汽车有油箱"""
        print('This Car need a gas tank!')

class Battery():
    """一次模拟电动汽车电瓶的简单尝试"""
    def __init__(self, battery_size=70):
        """初始化电瓶属性"""
        self.battery_size = battery_size

    def describe_battery(self):
        """打印一条描述电瓶容量的消息"""
        print('This Car has a ' + str(self.battery_size) + '-kwh battery.')

    def get_range(self):
        """打印一条消息, 指出电瓶的续航里程"""
        if self.battery_size == 70:
            range = 240
        elif self.battery_size == 85:
            range= 270

        message = 'This car can go approximately ' + str(range) + ' miles on a full charge.'
        print(message)


class ElectricCar(Car):
    """
    电动汽车的独特之处
    """
    def __init__(self, make, model, year):
        """
        初始化父类的属性
        再初始化电动汽车特有的属性
        """
        super().__init__(make, model, year)
        # 将实例用作属性
        self.battery = Battery()

    def fill_gas_tank(self):
        """电动汽车没有油箱"""
        print('This Car doesn‘s need a gas tank!')

# my_tesla = ElectricCar('tesla', 'model s', 2016)
# print(my_tesla.get_descriptive_name())
# # 测试 给子类定义属性和方法
# # my_tesla.describe_battery()
# # 测试 重写父类的方法
# my_tesla.fill_gas_tank()
# # 测试 将实例用作属性
# my_tesla.battery.describe_battery()
# my_tesla.battery.get_range()
