# 定义函数
def greet_user():
    """文档注释, 描述此函数的功能"""
    print("hello")

greet_user()

# 向函数传递信息
def greet_user(username):
    """显示简单的问候语"""
    print("Hello, " + username.title() + "!")

greet_user('tom')


# 位置实参
def describe_pet(animal_type, pet_name):
    """显示宠物的信息"""
    print("我的 " + animal_type + ' 的名字是 ' + pet_name)

describe_pet('狗', '小黄')
describe_pet('猫', '小黑')

# 关键字实参
describe_pet(pet_name='小红', animal_type='鸡')

# 默认值 默认值放在后面
def describe_pet2(pet_name, animal_type='dog'):
    """显示宠物的信息"""
    print("我的 " + animal_type + ' 的名字是 ' + pet_name)

describe_pet2(pet_name='小黄')
describe_pet2('大黄')
describe_pet2('大黄2', '狗')

# 默认值 默认值放在前面 SyntaxError: non-default argument follows default argument 会报错
# def describe_pet3(animal_type='dog', pet_name):
#     """显示宠物的信息"""
#     print("我的 " + animal_type + ' 的名字是 ' + pet_name)

# 返回值
def get_formatted_name(frist_name, last_name):
    """返回整洁的姓名"""
    full_name = frist_name + ' ' + last_name
    return full_name.title()

# 函数调用
musician = get_formatted_name('jimi', 'hendrix')
print(musician)

# 返回字典
def build_person(frist_name, last_name):
    """返回一个字典, 其中包含一个人的信息"""
    person = {'first': frist_name, 'last': last_name}
    return person

musician = build_person('jimi', 'hendrix')
print(musician)

# 在函数中修改列表
def print_models(unprinted_designs, completed_models):
    """
    模拟打印每个设计, 直到没有末打印的设计为止
    打印每个设计后, 都将其移到列表completed_models中
    """

    while unprinted_designs:
        current_design = unprinted_designs.pop()

        # 模拟根据设计制作3D打印模型的过程
        print('打印 模型: ' + current_design)
        completed_models.append(current_design)

def show_completed_models(completed_models):
    """显示打印好的所有模型"""
    print('\n打印好的模型：')
    for completed_model in completed_models:
        print(completed_model)

unprinted_designs = ['iphone case', 'robot pendant', 'dodecahedron']
completed_models = []
print('打印前 未打印的列表: ')
print(unprinted_designs)
# print_models(unprinted_designs, completed_models)
# unprinted_designs[:] 这个表示 unprinted_designs 列表的副本, 不会改变原来unprinted_designs的数据
print_models(unprinted_designs[:], completed_models)
show_completed_models(completed_models)

print('打印后 未打印的列表: ')
print(unprinted_designs)

# 传递任意参数的实参 *toppings
def make_pizza(*toppings):
    print(toppings)

# 看到打印结果 看打印的结果实际上是 使用元祖来存储 任意数量的实参的
make_pizza('peperoni')
make_pizza('mushrooms', 'green peppers', 5)

# 使用位置实参和任意数量实参
def make_pizza(size, *toppings):
    print(size)
    print(toppings)

make_pizza(16, 'green peppers', 'mushrooms')

# 使用任意数量的关键字实参
def build_profile(first, last, **user_info):
    """创建一个字典,包含我们知道的有关用户的一切"""
    profile = {}
    profile['frist_name'] = first
    profile['last_name'] = last
    for key, value in user_info.items():
        profile[key] = value
    return profile

user_profile = build_profile('albert', 'einstein', location='princeton', field='physics')
print(user_profile)
    